void SD_Recognition()
{
  LCDclear();
  LCDposition(1, 1);
  LcdSerial.print("Say Trigger!");
  digitalWrite(13,HIGH); // LED ON
  VRbot_RecognizeSD(0);      // start SI trigger word recognition
  cmd = VRbot_CheckResult(); // check recognition result
  speaker.Beep();
  digitalWrite(13,LOW); // LED OFF
  LCDclear();
  LCDposition(1, 1);
  LcdSerial.print("Group 1");
  LCDposition(2, 1);
  LcdSerial.print("Say a command!");
  digitalWrite(13,HIGH);  // LED ON
  VRbot_RecognizeSD(1);        // start SD recognition group 1
  cmd = VRbot_CheckResult();   // check recognition result
  speaker.Beep();
  digitalWrite(13,LOW); // LED OFF
  LCDclear();
  switch (cmd)
  {
    case 0: // USER SD WORD 0
      LCDposition(1, 1);
      LcdSerial.print("Command: Fire!");
      I2C_transmit(Mapper,Fire,0,0);
      delay(1000);
      fire=1;
      LCDclear();
      while (fire==1){Process_commands();}
      break;
    case 1: // USER SD WORD 1
      LCDposition(1, 1);
      LcdSerial.print("Command: Stop!");
      I2C_transmit(MotorController,StopAll,0,0);
      delay(200);
      break;
    case 2: // USER SD WORD 2
      LCDposition(1, 1);
      LcdSerial.print("Command: Fetch!");
      LCDposition(2, 1);
      LcdSerial.print("What object?");
      digitalWrite(13,HIGH);
      CheckFetch();
      break;
    case 3: // USER SD WORD 3
      LCDposition(1, 1);
      LcdSerial.print("Command: Sing!");
      dif.PlayMelody();      
      delay(200);
      break;
    case 4: // USER SD WORD 4
      LCDposition(1, 1);
      LcdSerial.print("Command: Dance!");
      //Dance();
      delay(200);
      break;
    case 5: // USER SD WORD 5
      LCDposition(1, 1);
      LcdSerial.print("Command: Thanks!");
      I2C_transmit(ServoController,ReleaseSO,0,0);
      delay(50);
      strcpy(text, "You are wellcome.");
      speech.say(text); 
      delay(200);
      break;
    case 6: // USER SD WORD 6
      LCDposition(1, 1);
      LcdSerial.print("Command: Scan!");
      I2C_transmit(Mapper,Scan,0,0);
      delay(200);
      break;
    case 7: // USER SD WORD 7
      LCDposition(1, 1);
      LcdSerial.print("Command: Move!");
      delay (200);
      LCDposition(2, 1);
      LcdSerial.print("Say a command!");
      digitalWrite(13,HIGH);
      CheckMove();
      break;
    case 8: // USER SD WORD 8
      LCDposition(1, 1);
      LcdSerial.print("Command: Turn!");
      delay (200);
      LCDposition(2, 1);
      LcdSerial.print("Say a command!");
      digitalWrite(13,HIGH);
      CheckTurn();
      break;
    case 9: // USER SD WORD 9
      LCDposition(1, 1);
      LcdSerial.print("Command: Hello!");
      I2C_transmit(ServoController, Wave,0,0);
      delay(50);
      strcpy(text, "Hello... My name is Mini Erik.");
      speech.say(text); 
      break;
    case 10: // USER SD WORD 10
      LCDposition(1, 1);
      LcdSerial.print("Command: PickUp");
      I2C_transmit(ServoController, PickUpSO,0,0);
      delay(200);
      break;
    case 11: // USER SD WORD 11
      LCDposition(1, 1);
      LcdSerial.print("Command: Servo");
      delay(200);
      LCDposition(2, 1);
      LcdSerial.print("Select servo!");
      digitalWrite(13,HIGH);
      SelectServo();
      break;
    case 12: // USER SD WORD 11
      LCDposition(1, 1);
      LcdSerial.print("Command: GrabIt");
      I2C_transmit(ServoController, PickUpBO,0,0);
      delay(200);
      break;
    case 13: // USER SD WORD 11
      LCDposition(1, 1);
      LcdSerial.print("Command: DropIt");
      I2C_transmit(ServoController, ReleaseBO,0,0);
      delay(200);
      break;
  }
}

void CheckFetch(){
  VRbot_RecognizeSD(2);       // start SD recognition group 2
  cmd = VRbot_CheckResult();  // check recognition result
  speaker.Beep();
  digitalWrite(13,LOW); // LED OFF
  switch (cmd){
    case 0: // USER SD WORD 0
      LCDposition(2, 1);
      LcdSerial.print("Object: Ball!");
      //Fetch(Ball);
      delay(50);
      strcpy(text, "Fetching the Ball.");
      speech.say(text); 
      delay(200);
      break;
    case 1:
      LCDposition(2, 1);
      LcdSerial.print("Object: Beer!");
      //Fetch(Beer);
      delay(50);
      strcpy(text, "Fetching a Beer.");
      speech.say(text); 
      delay(200);
      break;
    case 2:
      LCDposition(2, 1);
      LcdSerial.print("Object: Pepsi!");
      //Fetch(Pepsi);
      delay(50);
      strcpy(text, "Fetching a Pepsi.");
      speech.say(text); 
      delay(200);
      break;
    case 3:
      LCDposition(2, 1);
      LcdSerial.print("Object: Bear!");
      //Fetch(Bear);
      delay(50);
      strcpy(text, "Fetching the Teddy Bear.");
      speech.say(text); 
      delay(200);
      break;
  }
}  

void CheckMove(){
  VRbot_RecognizeSI(2);       // start SI recognition wordset 2
  cmd = VRbot_CheckResult();  // check recognition result
  speaker.Beep();
  digitalWrite(13,LOW); // LED OFF
  switch (cmd){
    case 4:  // FORWARD
      LCDposition(2, 1);
      LcdSerial.print("Command: FWD! ");
      I2C_transmit(MotorController,Forward,0,200);
      delay(50);
      strcpy(text, "Moving forward.");
      speech.say(text); 
      delay(200);
      LCDclear();
      LCDposition(1, 1);
      LcdSerial.print("Say a command!");
      digitalWrite(13,HIGH);
      CheckStop();
      break;
    case 5:  // BACKWARD
      LCDposition(2, 1);
      LcdSerial.print("Command: BWD! ");
      I2C_transmit(MotorController,Reverse,0,200);
      delay(50);
      strcpy(text, "Moving backward.");
      speech.say(text); 
      delay(200);
      LCDclear();
      LCDposition(1, 1);
      LcdSerial.print("Say a command!");
      digitalWrite(13,HIGH);
      CheckStop();
      break;
  }
}

void CheckTurn(){
  VRbot_RecognizeSI(2);       // start SI recognition wordset 2     
  cmd = VRbot_CheckResult();  // check recognition result
  speaker.Beep();
  digitalWrite(13,LOW); // LED OFF
  switch (cmd){
    case 0: // LEFT
      LCDposition(2, 1);
      LcdSerial.print("Command: LEFT!");
      I2C_transmit(MotorController,Left,0,200);
      delay(50);
      strcpy(text, "Turning left.");
      speech.say(text); 
      delay (200);
      LCDclear();
      LCDposition(1, 1);
      LcdSerial.print("Say a command!");
      digitalWrite(13,HIGH);
      CheckStop();
      break;
    case 1:
      LCDposition(2, 1);
      LcdSerial.print("Command: RIGHT!");
      I2C_transmit(MotorController,Right,0,200);
      delay(50);
      strcpy(text, "Turning right.");
      speech.say(text); 
      delay (200);
      LCDclear();
      LCDposition(1, 1);
      LcdSerial.print("Say a command!");
      digitalWrite(13,HIGH);
      CheckStop();
      break;
  }
}

void CheckStop(){
  do{
    VRbot_RecognizeSD(1);        // start SD recognition group 1
    cmd = VRbot_CheckResult();   // check recognition result
  }while (cmd!=1);
  speaker.Beep();
  digitalWrite(13,LOW); // LED OFF
  LCDposition(2, 1);
  LcdSerial.print("Command: Stop!");
  I2C_transmit(MotorController,StopAll,0,0);
  delay(200);
}  

void SelectServo(){
  VRbot_RecognizeSD(2);       // start SD recognition group 2     
  cmd = VRbot_CheckResult();  // check recognition result
  //speaker.Beep();
  digitalWrite(13,LOW); // LED OFF
  byte Sv=0;
    switch (cmd){
      case 4: // WAIST
        Sv=Swaist;
        LCDposition(2, 1);
        LcdSerial.print("Servo: Waist!   ");
        delay (200);
        LCDclear();
        LCDposition(1, 1);
        LcdSerial.print("Say a command!");
        digitalWrite(13,HIGH);
        do{CheckPosition(Sv);}while (cmd!=16); //exit after Store Position
        break;
      case 5: // LEFT SHOULDER
        Sv=SleftSh;
        LCDposition(2, 1);
        LcdSerial.print("Servo: L Shlder!");
        delay (200);
        LCDclear();
        LCDposition(1, 1);
        LcdSerial.print("Say a command!");
        digitalWrite(13,HIGH);
        do{CheckPosition(Sv);}while (cmd!=16); //exit after Store Position
        break;
      case 6: // RIGHT SHOULDER
        Sv=SrightSh;
        LCDposition(2, 1);
        LcdSerial.print("Servo: R Shlder!");
        delay (200);
        LCDclear();
        LCDposition(1, 1);
        LcdSerial.print("Say a command!");
        digitalWrite(13,HIGH);
        do{CheckPosition(Sv);}while (cmd!=16); //exit after Store Position
        break;
      case 7: // LEFT ARM
        Sv=SleftArm;
        LCDposition(2, 1);
        LcdSerial.print("Servo: L Arm!   ");
        delay (200);
        LCDclear();
        LCDposition(1, 1);
        LcdSerial.print("Say a command!");
        digitalWrite(13,HIGH);
        do{CheckPosition(Sv);}while (cmd!=16); //exit after Store Position
        break;
      case 8: // RIGHT ARM
        Sv=SrightArm;
        LCDposition(2, 1);
        LcdSerial.print("Servo: R Arm!   ");
        delay (200);
        LCDclear();
        LCDposition(1, 1);
        LcdSerial.print("Say a command!");
        digitalWrite(13,HIGH);
        do{CheckPosition(Sv);}while (cmd!=16); //exit after Store Position
        break;
      case 9: // SCANNER
        Sv=Sscan;
        LCDposition(2, 1);
        LcdSerial.print("Servo: Scanner! ");
        delay (200);
        LCDclear();
        LCDposition(1, 1);
        LcdSerial.print("Say a command!");
        digitalWrite(13,LOW);
        do{CheckPosition(Sv);}while (cmd!=16); //exit after Store Position
        break;
      case 10: // PAN
        Sv=SpanHead;
        LCDposition(2, 1);
        LcdSerial.print("Servo: Pan Head!");
        delay (200);
        LCDclear();
        LCDposition(1, 1);
        LcdSerial.print("Say a command!");
        digitalWrite(13,HIGH);
        do{CheckPosition(Sv);}while (cmd!=16); //exit after Store Position
        break;
      case 11: // TILT
        Sv=StiltHead;
        LCDposition(2, 1);
        LcdSerial.print("Servo: TiltHead!");
        delay (200);
        LCDclear();
        LCDposition(1, 1);
        LcdSerial.print("Say a command!");
        digitalWrite(13,HIGH);
        do{CheckPosition(Sv);}while (cmd!=16); //exit after Store Position
        break;
  }
}

void CheckPosition(byte servo){
  VRbot_RecognizeSD(2);        // start SD recognition group 2
  cmd = VRbot_CheckResult();   // check recognition result
  speaker.Beep();
  digitalWrite(13,LOW); // LED OFF
  switch (cmd){
    case 12: // UP
      LCDposition(2, 1);
      LcdSerial.print("Command: Up!    ");
      I2C_transmit(ServoController,Up,servo,0);
      delay(200);
      break;
    case 13: // DOWN
      LCDposition(2, 1);
      LcdSerial.print("Command: Down!  ");
      I2C_transmit(ServoController,Down,servo,0);
      delay(200);
      break;
    case 14: // LEFT
      LCDposition(2, 1);
      LcdSerial.print("Command: Left!  ");
      I2C_transmit(ServoController,Left,servo,0);
      delay(200);
      break;
    case 15: // RIGHT
      LCDposition(2, 1);
      LcdSerial.print("Command: Right! ");
      I2C_transmit(ServoController,Right,servo,0);
      delay(200);
      break;
    case 16: // STORE POSITION
      LCDposition(2, 1);
      LcdSerial.print("Command: Store! ");
      I2C_transmit(ServoController,StorePos,servo,0);
      delay(200);
      break;
  }
}

void VRbot_setup()
{
  _baudRate = 9600;
  _bitPeriod = 1000000 / _baudRate;
  _receivePin = 2;
  _transmitPin = 3;
  digitalWrite(_transmitPin, HIGH);
  delayMicroseconds( _bitPeriod); 
}

unsigned char VRbot_read(void)
{
  uint8_t val = 0;
  int bitDelay = _bitPeriod - clockCyclesToMicroseconds(100);
  
  // one byte of serial data (LSB first)
  // ...--\    /--\/--\/--\/--\/--\/--\/--\/--\/--...
  //	 \--/\--/\--/\--/\--/\--/\--/\--/\--/
  //	start  0   1   2   3   4   5   6   7 stop

  while (digitalRead(_receivePin));

  // confirm that this is a real start bit, not line noise
  if (digitalRead(_receivePin) == LOW) {
    // frame start indicated by a falling edge and low start bit
    // jump to the middle of the low start bit
    delayMicroseconds(bitDelay / 2 - clockCyclesToMicroseconds(50));
	
    // offset of the bit in the byte: from 0 (LSB) to 7 (MSB)
    for (int offset = 0; offset < 8; offset++) {
	// jump to middle of next bit
	delayMicroseconds(bitDelay);
	
	// read bit
	val |= digitalRead(_receivePin) << offset;
    }
	
    delayMicroseconds(_bitPeriod);
    
    return val;
  }
  
  return -1;
}

void VRbot_write(uint8_t b)
{
  if (_baudRate == 0)
    return;
    
  int bitDelay = _bitPeriod - clockCyclesToMicroseconds(50); // a digitalWrite is about 50 cycles
  byte mask;

  digitalWrite(_transmitPin, LOW);
  delayMicroseconds(bitDelay);

  for (mask = 0x01; mask; mask <<= 1) {
    if (b & mask){ // choose bit
      digitalWrite(_transmitPin,HIGH); // send 1
    }
    else{
      digitalWrite(_transmitPin,LOW); // send 1
    }
    delayMicroseconds(bitDelay);
  }

  digitalWrite(_transmitPin, HIGH);
  delayMicroseconds(bitDelay);
}

unsigned char VRbot_Detect(void) {
  unsigned char i;
  for (i = 0; i < 5; ++i) {
    delay(100);
    VRbot_write(CMD_BREAK);
    if ( VRbot_read() == STS_SUCCESS)
      return 255;
  }
  return 0;
}

unsigned char VRbot_SetLanguage(unsigned char lang) {
        
  VRbot_write(CMD_LANGUAGE);
  delay(5);
  VRbot_write(ARG_ZERO + lang);

  if (VRbot_read() == STS_SUCCESS)
    return 255;
  return 0;
}

void VRbot_RecognizeSD(unsigned char group) {
  VRbot_write(CMD_RECOG_SD);
  delay(5);
  VRbot_write(ARG_ZERO + group);
}

void VRbot_RecognizeSI(unsigned char ws) {
  VRbot_write(CMD_RECOG_SI);
  delay(5);
  VRbot_write(ARG_ZERO + ws);
}

signed char VRbot_CheckResult(void) {
  
  unsigned char rx;
  rx = VRbot_read();
  if (rx == STS_SIMILAR || rx == STS_RESULT) {
    delay(5);
    VRbot_write(ARG_ACK);
    return (VRbot_read() - ARG_ZERO);
  }
  return -2;
}

unsigned char VRbot_GetGroupCount(unsigned char group) {
  unsigned char rx;
  VRbot_write(CMD_COUNT_SD);
  delay(5);
  VRbot_write(ARG_ZERO + group);
  if (VRbot_read() == STS_COUNT) {
    delay(5);
    VRbot_write(ARG_ACK);
    return VRbot_read() - ARG_ZERO;
  }
  return 0;
}
 
